<?php 
//Copyright (c) 2009 Switzernet, written by Kerim Teboulbi 

$home_folder_name="../";
$file_folder_name="versions/";
$source_folder_name="source/";
$admin_folder_name="admin/";
$extension_direct_view=array("htm", "html", "txt");
$html1="<html>\n<head>\n</head>\n<body>\n<textarea readonly name=content cols=80 rows=45 >\n";
$html2="\n</textarea>\n</body>\n</html>";

function generate_password() {
	$n=2;
	$result="";
	$chars = array_merge(range('a','z'),range('A','Z'),range(0,9));
	for($i=0;$i<$n;$i++) 
	{ 
		$result .= $chars[mt_rand(0,count($chars)-1)]; 
	}
	return $result;
}

function is_writable_and_readable($path="."){
	if (file_exists($path)){
		$global_perms=substr(sprintf('%o', fileperms($path)), -4);
		$own_perms=substr($global_perms,-3,1);
		$group_perms=substr($global_perms,-2,1);
		$all_perms=substr($global_perms,-1,1);
		if (($own_perms==7||$global_perms==6)&&($group_perms==7||$group_perms==6)&&($all_perms==7||$all_perms==6)) {
			return true;
		}
		return false;
	}
	return true;
}

function get_htpasswd_content($user, $password) {
	$result="";
	$salt = generate_password(); 
	$result.= $user.":".crypt($password,$salt);
	return $result;
}

function get_file_name($ext="htm", $subject="") {
	global $home_folder_name;
	$subject = strtr(stripslashes($_POST['subject']),", ",";-");
	if (!check_htaccess_present($home_folder_name)){
		if (isset($_POST['user'])){
			$user=$_POST['user'];
		}
		else {
			$user="Anonymous";
		}
	}
	else {
		$user=$_SERVER['REMOTE_USER'];
	}
	$file_name=date('ymd,His,').$user.",".$subject.".".$ext;
	$file_name = strtr($file_name,"","AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn");
	return $file_name;
}


function get_extension ($file_folder_name) {
	$array_part=explode (".", $file_folder_name);
	return array_pop($array_part);
}

function list_data_folder ($folder_name) {
	$dir=opendir($folder_name);
	while (($file = readdir($dir)) != false) {
		$regexp="/^\d{6},\d{6},.+,.*\.\w{2,5}$/";
		if (preg_match($regexp, $file)){
				$files[]=$file;
		}
	}
	if (is_array($files)){
		rsort($files);
		return $files;
	}
	return false;
}

function list_complete_folder ($folder_name) {
	$dir=opendir($folder_name);
	while (($file = readdir($dir)) != false) {
			$files[]=$file;
	}
	if (is_array($files)){
		rsort($files);
		return $files;
	}
	return false;
}

function get_file_subject ($file) {
	$regexp="/^\d{6},\d{6},.+,(.*)\.\w{2,5}$/";
	if (preg_match($regexp, $file, $result)){
			return $result[1];
	}
	return false;
}

function get_file_proprietery ($file) {
	$regexp="/^\d{6},\d{6},(.+),.*\.\w{2,5}$/";
	if (preg_match($regexp, $file, $result)){
			return $result[1];
	}
	return false;
}

function get_files_proprieteries ($folder_name) {
	$dir=opendir($folder_name);
	while (($file = readdir($dir)) != false) {
		$regexp="/^\d{6},\d{6},.+,.*\.\w{2,5}$/";
		if (preg_match($regexp, $file)){
				if (!is_array($names)){
					$names=array();
				}
				$name=get_file_proprietery($file);
				if (!in_array($name, $names)){
					$names[]=$name;
				}
		}
	}
	if (!in_array("Anonymous", $names)){
		$names[]="Anonymous";
	}
	if (is_array($names)){
		sort($names);
		return $names;
	}
	return false;
}

function get_last_direct_view ($files) {
	global $extension_direct_view;
	if (!is_array($files)){
		return false;
	}
	rsort($files);
	foreach ($files as $file) {
		if (in_array(get_extension($file), $extension_direct_view)){
			return $file;
		}
	}
	return false;
}

function check_uploadable ($file_name) {
	$regexp="/^[\w|\W]*\.(php|asp)$/";
	if (preg_match($regexp, $file_name, $value)){
		return false;
	}
	$regexp="/^[\w|\W]*\.pl(\.[\W|\w]*)*$/";
	if (preg_match($regexp, $file_name, $value)){
		return false;
	}
	$regexp="/^.+\.[^.]{1,4}$/";
	if (preg_match($regexp, $file_name, $value)){
		return true;
	}
	return false;
}

function add_get_param($current_get, $ref, $value) {
	if ($current_get=="") {
		$current_get="?".$ref."=".$value;
	}
	else {
		$current_get.="&".$ref."=".$value;
	}
	return $current_get;
}

function unzip($file, $destination_path='', $delete_zip=true){

	$tab_liste_fichiers = array(); 

	$zip = zip_open($file);
	if ($zip){
		//read and write all the file from the zip file
		while ($zip_entry = zip_read($zip)) {
			if (zip_entry_filesize($zip_entry) > 0) {
				$complete_path = $destination_path.dirname(zip_entry_name($zip_entry));
				$file_name = zip_entry_name($zip_entry);
				$file_name = strtr($file_name,"","AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn");
				$file_name = strtolower($file_name);
				$file_name = ereg_replace('[^a-zA-Z0-9.]','-',$file_name);
				//we add the file name to the array to write them later
				array_push($tab_liste_fichiers,$file_name);
				$complete_name = $destination_path.$file_name;
				//create the folder if it doesn't exist
				if(!file_exists($complete_path)){
					$tmp = '';
					foreach(explode('/',$complete_path) AS $k){
						$tmp .= $k.'/';
						if(!file_exists($tmp)){ 
							mkdir($tmp, 0777); 
							chmod($tmp, 0777);
						}
					}
				}
				//extract the file
				if (zip_entry_open($zip, $zip_entry, "r")) {
					if(file_exists($complete_name)){
						unlink($complete_name);
					}
					$fd = fopen($complete_name, 'w');
					fwrite($fd, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
					fclose($fd);
					chmod($complete_name, 0777);
					zip_entry_close($zip_entry);
				}
			}
		}
		zip_close($zip);
		//We may delete the file
		if ($delete_zip == true) {
			unlink($file);
		}
	}
	return $tab_liste_fichiers;
} 

function update_last_version(){
	global $home_folder_name,$source_folder_name;
	$fp=fopen("http://www.switzernet.com/public/090420-manage-version-repository/last.txt", "r");
	$txt=fgets($fp);
	fclose($fp);
	$txt=trim($txt);
	$fp=fopen($home_folder_name.$source_folder_name."version.txt", "r");
	$version=fgets($fp);
	fclose($fp);
	if ($txt>$version) {
		copy('http://www.switzernet.com/public/090420-manage-version-repository/v'.$txt.'.zip','v'.$txt.'.zip');
		unzip('v'.$txt.'.zip');
		return true;
	}
	return false;

}

function write_txt_2_html ($txt) {
	global $home_folder_name,$file_folder_name, $html1, $html2;
	$html=$html1.$txt.$html2;
	$new_file_name=get_file_name('htm');
	$fh = fopen($home_folder_name.$file_folder_name.$new_file_name, 'w');
	fwrite($fh, $html);
	fclose($fh);
}

function write_htaccess($local_path) {
	$complete_path=substr($_SERVER['SCRIPT_FILENAME'], 0, strrpos($_SERVER['SCRIPT_FILENAME'], '/'));
	$file=$local_path.".htaccess";
	while (substr($local_path, 0, 3)=="../") {
		$local_path=substr($local_path, 3);
		$complete_path=substr($complete_path, 0, strrpos($complete_path, '/'));
		$complete_path=substr($complete_path, 0, strrpos($complete_path, '/'));
	}
	if (substr($local_path, 0, 2)=="..") {
		$local_path=substr($local_path, 2);
		$complete_path=substr($complete_path, 0, strrpos($complete_path, '/'));
	}
	elseif (substr($local_path, 0, 2)=="./"){
		$local_path=substr($local_path, 2);
	}

	$complete_path.="/";
	if ($local_path!="") {
		$complete_path.=$local_path;
	}
	$fp=fopen($file, 'w');
	fwrite($fp, "SetEnvIfNoCase Request_URI \.ht(access|passwd)$ ban\n");
	fwrite($fp, "<Files ~ \"^.*$\">\n");
	fwrite($fp, "order allow,deny\n");
	fwrite($fp, "allow from all\n");
	fwrite($fp, "deny from env=ban\n");
	fwrite($fp, "</Files>\n\n");
	fwrite($fp, "Authname \"Area Protected\"\n");
	fwrite($fp, "AuthUserFile ".$complete_path.".htpasswd"."\n");
	fwrite($fp, "AuthGroupFile /dev/null\n");
	fwrite($fp, "AuthType Basic\n");
	fwrite($fp, "<limit GET POST>\n");
	fwrite($fp, "require valid-user\n");
	fwrite($fp, "</limit>\n\n");
	fwrite($fp, "ErrorDocument 404 /404.html\n");
	fclose($fp);
	chmod ($file, 0777);
}

function update_htpasswd ($path, $user, $password) {
	$fp=fopen($path.".htpasswd", 'r');
	while (!feof($fp)) {
		$lines[]=fgets($fp);
	}
	fclose($fp);
	unlink($path.".htpasswd");
	$fp=fopen($path.".htpasswd", 'w');
	foreach ($lines as $line){
		$regexp="/^".$user.":.+/";
		if (preg_match($regexp, $line)){
			$line=get_htpasswd_content($user, $password)."\r\n";
		}
		fwrite($fp, $line);
	}
	fclose($fp);
	chmod($path.".htpasswd", 0777);
}

function check_htaccess_present ($path="./") {
	return is_file($path.".htaccess");
}

function check_authentification() {
	return isset($_SERVER['REMOTE_USER']);
}

function get_username() {
	return $_SERVER['REMOTE_USER'];
}

function rmdir_recurse($path) { 
    $path= rtrim($path, '/').'/'; 
    $handle = opendir($path); 
    for (;false !== ($file = readdir($handle));) 
        if($file != "." and $file != ".." ) { 
            $fullpath= $path.$file; 
            if( is_dir($fullpath)) { 
                rmdir_recurse($fullpath); 
            } else { 
                unlink($fullpath); 
            } 
    } 
    closedir($handle);
	chmod ($path, 0777);
    rmdir($path); 
} 
?>